SystemOrganization addCategory: #Metaprogramacion!

!Behavior class methodsFor: '*Metaprogramacion' stamp: 'pb 6/19/2013 19:47'!
messageNotPresent
	^'this class does not respond to this message'! !

!Behavior methodsFor: '*Metaprogramacion' stamp: 'pb 6/19/2013 19:56'!
subclassesNotImplementing: aMessageSelector 
	|method|
	method := self methodDictionary at: aMessageSelector ifAbsent: [
		self error: Behavior messageNotPresent 
	].
	^#().! !

Object subclass: #TheParentClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!TheParentClass methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 19:31'!
implementedMethod
	! !

!TheParentClass methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 19:32'!
notImplementedMethod
 	self subclassResponsibility.! !

TestCase subclass: #MetaprogrammingTestCase
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 19:49'!
testShouldFailIfAskingForUnknownMethod
	self should: [TheParentClass subclassesNotImplementing: #unknown] 
		 raise: Error
		 withExceptionDo: [ :anError | self assert: anError messageText = Behavior messageNotPresent].! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 19:37'!
testShouldListNoClasesOnImplementedMethod
	| subclasses |
	subclasses := TheParentClass subclassesNotImplementing: #implementedMethod.
	self assert: subclasses isEmpty.! !
